// honeycomb structure

DefineConstant[ l = { 10.0, Min 1, Max 20, Step 1, Name "Lengths/hex edge length" }  ];
DefineConstant[ k = {  1.0, Min 1, Max  2, Step 1, Name "Lengths/bound. thickness" }  ];
DefineConstant[ lc = {  1./3, Min 1e-5, Max  1, Step 1e-5, Name "Mesh/density" }  ];


alp=30*Pi/180;

Point(1) = {0, 0, 0, lc};
Point(2) = {l*Cos(alp), l*Sin(alp), 0, lc};
Point(3) = {l*Cos(alp), l*Sin(alp)+l, 0, lc};
Point(4) = {0, 2*l*Sin(alp)+l, 0, lc};
Point(5) = {-l*Cos(alp), l*Sin(alp), 0, lc};
Point(6) = {-l*Cos(alp), l*Sin(alp)+l, 0, lc};

Line(1) = {1, 2};
Line(2) = {2, 3};
Line(3) = {3, 4};
Line(4) = {4, 6};
Line(5) = {6, 5};
Line(6) = {5, 1};

Point(7) = {-k*Sin(alp), -k*Cos(alp), 0, lc};
Point(8) = {+k*Sin(alp), -k*Cos(alp), 0, lc};
Point(9) = {-k*Sin(alp)-l*Cos(alp), -k*Cos(alp)+l*Sin(alp), 0, lc};
Point(10) = {+k*Sin(alp)+l*Cos(alp), -k*Cos(alp)+l*Sin(alp), 0, lc};
Point(11) = {-k*Sin(alp), -k*Cos(alp)-l/2, 0, lc};
Point(12) = {+k*Sin(alp), -k*Cos(alp)-l/2, 0, lc};
Point(13) = {-k*Sin(alp)-l*Cos(alp), -k*Cos(alp)-l/2, 0, lc};
Point(14) = {+k*Sin(alp)+l*Cos(alp), -k*Cos(alp)-l/2, 0, lc};


Point(15) = {-k*Sin(alp), 2*l*Sin(alp)+l+k*Cos(alp), 0, lc};
Point(16) = {+k*Sin(alp), 2*l*Sin(alp)+l+k*Cos(alp), 0, lc};
Point(17) = {-k*Sin(alp)-l*Cos(alp), 2*l*Sin(alp)+l+k*Cos(alp)-l*Sin(alp), 0, lc};
Point(18) = {+k*Sin(alp)+l*Cos(alp), 2*l*Sin(alp)+l+k*Cos(alp)-l*Sin(alp), 0, lc};
Point(19) = {-k*Sin(alp), 2*l*Sin(alp)+l+k*Cos(alp)+l/2, 0, lc};
Point(20) = {+k*Sin(alp), 2*l*Sin(alp)+l+k*Cos(alp)+l/2, 0, lc};
Point(21) = {-k*Sin(alp)-l*Cos(alp), 2*l*Sin(alp)+l+k*Cos(alp)+l/2, 0, lc};
Point(22) = {+k*Sin(alp)+l*Cos(alp), 2*l*Sin(alp)+l+k*Cos(alp)+l/2, 0, lc};


Line(7) = {13, 11};
Line(8) = {11, 12};
Line(9) = {12, 14};
Line(10) = {14, 10};
Line(11) = {10, 18};
Line(12) = {18, 22};
Line(13) = {22, 20};
Line(14) = {20, 19};
Line(15) = {19, 21};
Line(16) = {21, 17};
Line(17) = {17, 9};
Line(18) = {9, 13};
Line(19) = {11, 7};
Line(20) = {7, 9};
Line(21) = {8, 12};
Line(22) = {8, 10};
Line(23) = {18, 16};
Line(24) = {16, 20};
Line(25) = {19, 15};
Line(26) = {15, 17};


Line Loop(27) = {4, 5, 6, 1, 2, 3};
Plane Surface(28) = {27};
Line Loop(29) = {20, 18, 7, 19};
Plane Surface(30) = {29};
Line Loop(31) = {-22, +10, +9, +21};
Plane Surface(32) = {31};
Line Loop(33) = {-23, -24, +13, +12};
Plane Surface(34) = {33};
Line Loop(35) = {-26, +16, +15, -25};
Plane Surface(36) = {35};

Line Loop(37) = {-26, -17, +20, +19, -8, +21, -22, -11, -23, -24, -14, -25};
Plane Surface(38) = {27, 37};

Physical Line("Left") = {16, 17, 18};
Physical Line("Right") = {10, 11, 12};
Physical Line("Bottom") = {7, 8, 9};
Physical Line("Top") = {15, 14, 13};

Physical Surface("Hexagon") = {28, 32, 30, 36, 34};
Physical Surface("Borders") = {38};



Physical Point("P1") = {13};



